Option Explicit

Const WelcomeText = "Hello, this is a calculator application. Please enter a number then press star and enter a second number. To calculate the sum of those numbers, press cross."
Const ErrorText = "An error has occured"

Const csWelcome = 0
Const csFirstOperand = 1
Const csSecondOperand = 2
Const csResult = 3
Const csError = 9

Dim FirstOperand
Dim SecondOperand

Dim CalculatorState



Sub CallHandler_Init()

End Sub

Sub CallHandler_DigitReceived(Digit)

    Select Case CalculatorState
    Case csWelcome, csFirstOperand
        Select Case Digit
        Case "0", "1", "2", "3", "4", "5", "6", "7", "8", "9"
            FirstOperand = FirstOperand & Digit
            CalculatorState = csFirstOperand
            CallController.StopPlayRecord
        Case "*"
            If FirstOperand = "" Then
                'At least one digit is needed for first operand
                CallController.StopPlayRecord
                CalculatorState = csError
            Else
                'Now wait for input of second operand
                CalculatorState = csSecondOperand
            End If
        Case Else
            'A wrong digit was entered
            CalculatorState = csError
            CallController.StopPlayRecord
        End Select
    Case csSecondOperand
        Select Case Digit
        Case "0", "1", "2", "3", "4", "5", "6", "7", "8", "9"
            SecondOperand = SecondOperand & Digit
        Case "#"
            If SecondOperand = "" Then
                'At least one digit is needed for second operand
                CallController.StopPlayRecord
                CalculatorState = csError
            Else
                'Now calculate and output result
                CalculatorState = csResult
            End If
        Case Else
            'A wrong digit was entered
            CalculatorState = csError
            CallController.StopPlayRecord
        End Select
    Case Else
        'Ignore this digit in all other states
    End Select
        
End Sub

Sub CallHandler_FileSaved(FileName, Length)
    'This procedure is not needed in this sample
    'All procedures of ITVCallHandler must be implemented though!
End Sub

Sub CallHandler_PlayDone()

    Select Case CalculatorState
    Case csWelcome
        CalculatorState = csFirstOperand
    Case csResult
        CalculatorState = csWelcome
    Case csError
        CalculatorState = csWelcome
    End Select

End Sub

Sub CallHandler_TimePulse()
Dim Result
Dim FileArray
Dim i
Dim StrResult

    Select Case CalculatorState
    Case csWelcome
        If Not CallController.IsPlaying Then
            If Not CallController.PlayTTS(WelcomeText) Then
                CallController.WriteLogFile 10, "Unable to play TTS", True
                CallController.HangUp
            End If
        End If
    Case csResult
        If Not CallController.IsPlaying Then
            Result = CStr(CLng(FirstOperand) + CLng(SecondOperand))
            StrResult = "The result of " & FirstOperand & " + " & SecondOperand
            StrResult = StrResult & " is " & Result
            FirstOperand = ""
            SecondOperand = ""
            If Not CallController.PlayTTS(StrResult) Then
                CallController.WriteLogFile 12, "Unable to play TTS", True
                CallController.HangUp
            End If
            StrResult = ""
        End If
    Case csError
        If Not CallController.IsPlaying Then
            If Not CallController.PlayTTS(ErrorText) Then
                CallController.WriteLogFile 14, "Unable to play TTS", True
                CallController.HangUp
            End If
        End If
    End Select


    
End Sub

Sub CallHandler_UnInit()
    
    'Destroy all objects here
    
End Sub
